// SimplexContainer.cc

#include "Voronoi.h"
#include "SimplexContainer.h"
#include <iostream>

void die_simplex_container(const char* last_words)
{
  std::cout <<"SimplexContainer.cc: " <<last_words;
  exit(EXIT_FAILURE);
}

SimplexContainer::SimplexContainer()
{
}

SimplexContainer::~SimplexContainer()
{
}

SimplexContainer::SimplexContainer(const SimplexContainer& SC)
{
  die_simplex_container("copy constructor invoked.\n");
}

SimplexContainer& SimplexContainer::operator=(const SimplexContainer &SC)
{
  die_simplex_container("operator= invoked.\n");
  return *this; // just to prevent a compiler warning
}

Simplex* SimplexContainer::add_simplex(const Simplex& L)
{  
  std::set< std::pair<Simplex, int> >::iterator pos = simplices.find(std::make_pair(L, 0));
  if (pos == simplices.end()) 
    return const_cast<Simplex*>(&((*simplices.insert(std::make_pair(L, 1)).first).first));
  else {
    const_cast<int&>((*pos).second)++;
    return const_cast<Simplex*>(&((*pos).first));
  }
}

void SimplexContainer::delete_simplex(const Simplex& L)
{
  
  std::set< std::pair<Simplex, int> >::iterator pos = simplices.find(std::make_pair(L, 0));
  if (pos == simplices.end())
    die_simplex_container("pos == simplices.end()\n");
  const_cast<int&>((*pos).second)--;
  
  if ((*pos).second == 0)
    simplices.erase(pos);
}

