// SimplexContainer.h

#ifndef _SIMPLEX_CONTAINER_H
#define _SIMPLEX_CONTAINER_H

#include <set>

#include "Simplex.h"

struct SimplexPairLess
{
  bool operator()(const std::pair<Simplex, int> &a, const std::pair<Simplex, int> &b) const
  {
    return a.first < b.first;
  }     
};

class SimplexContainer {
 public:
  SimplexContainer();
  ~SimplexContainer();
  
  SimplexContainer(const SimplexContainer& SC);
  SimplexContainer& operator=(const SimplexContainer& SC);
  
  Simplex* add_simplex(const Simplex& L);
  void delete_simplex(const Simplex& L);
  
 private:
  std::set< std::pair<Simplex, int>, SimplexPairLess> simplices;
};

#endif
